/*
 *   FreeAdhocUDF - copyright (c) 2004/2006 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *
 *   !!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!
 *   This is a update-script for your FreeAdhocUDf-conv-functions (ex math)
 *   if you want to use the posibility of return NULL in FireBird 2.0 (only!!!)
 *   if you want to use the version adhoc200612xx (or further versions)
 *   AND you have DECLAIRED your UDFs with an older version then adhoc200612xx
 *   OR with a compatible version of this UDFs like FreeUDFLib, FreeUDFLibC, GrUDF ...
 *   You MUST FIRST run the adhoc200612update_conv.sql-script!
 *   You can run the COMPLETE script even you have NOT all UDFs declaired.
 *
 *   AFTER running this update-script you must REconnect to your database before you test
 *
 *   Software distributed under the License is distributed on an
 *   "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 *   or implied. See the License for the specific language governing
 *   rights and limitations under the License.
 *
 */

/* all FreeAdhocUDFs using entrypoint 'convertfrom33' f.e. F_CONVERTFROM33 */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'convertfrom33');

/* all FreeAdhocUDFs using entrypoint 'convertfrombase' f.e. F_CONVERTFROMBASE */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'convertfrombase');

/* all FreeAdhocUDFs using entrypoint 'hextoint' f.e. F_HEXTOINT */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'hextoint');

/* all FreeAdhocUDFs using entrypoint 'degtorad' f.e. F_DEGTORAD */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'degtorad');

/* all FreeAdhocUDFs using entrypoint 'radtodeg' f.e. F_RADTODEG */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'radtodeg');

/* adhoc 2006-11-30 */
