/*
 *   FreeAdhocUDF - copyright (c) 2004/2006 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *
 *   !!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!
 *   This is a NECESSARY update-script for your FreeAdhocUDf-math-functions
 *   if you want to use the version adhoc200612xx (or further versions)
 *   AND you have DECLAIRED your UDFs with an older version then adhoc200612xx
 *   OR with a compatible version of this UDFs like FreeUDFLib, FreeUDFLibC, GrUDF ...
 *   EVEN you don't want to use the NULL-Return in FireBird 2.0 or you use InterBase.
 *   You can run the COMPLETE script even you have NOT all UDFs declaired.
 *
 *   AFTER running this update-script you must REconnect to your database before you test
 *
 *   Software distributed under the License is distributed on an
 *   "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 *   or implied. See the License for the specific language governing
 *   rights and limitations under the License.
 *
 */

/* changing entrypoint for F_TRUNCATE */
UPDATE RDB$FUNCTIONS F SET F.RDB$ENTRYPOINT = 'f_truncate'
WHERE F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'truncate';

/* changing entrypoint for F_ROUND */
UPDATE RDB$FUNCTIONS F SET F.RDB$ENTRYPOINT = 'f_round'
WHERE F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'round';

/* all FreeAdhocUDFs using entrypoint 'doubleabs' f.e. F_DOUBLEABS */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'doubleabs');

/* all FreeAdhocUDFs using entrypoint 'equalfloat' f.e. F_EQUALFLOAT */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'equalfloat');

/* all FreeAdhocUDFs using entrypoint 'equalinteger' f.e. F_EQUALINTEGER */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'equalinteger');

/* all FreeAdhocUDFs using entrypoint 'fact' f.e. F_FACT */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'fact');

/* all FreeAdhocUDFs using entrypoint 'integerabs' f.e. F_INTEGERABS */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'integerabs');

/* all FreeAdhocUDFs using entrypoint 'isdivisibleby' f.e. F_ISDIVISIBLEBY */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'isdivisibleby');

/* all FreeAdhocUDFs using entrypoint 'maxnum' f.e. F_MAX */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND (F.RDB$ENTRYPOINT = 'maxnum' OR F.RDB$ENTRYPOINT = 'max'));

/* all FreeAdhocUDFs using entrypoint 'minnum' f.e. F_MIN */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND (F.RDB$ENTRYPOINT = 'minnum' OR F.RDB$ENTRYPOINT = 'min'));

/* all FreeAdhocUDFs using entrypoint 'modulo' f.e. F_MODULO */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'modulo');

/* all FreeAdhocUDFs using entrypoint 'prozente' f.e. F_PROZENTE */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'prozente');

/* all FreeAdhocUDFs using entrypoint 'round' f.e. F_ROUND */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND (F.RDB$ENTRYPOINT = 'round' OR F.RDB$ENTRYPOINT = 'f_round'));

/* all FreeAdhocUDFs using entrypoint 'roundfloat' f.e. F_ROUNDFLOAT */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'roundfloat');

/* all FreeAdhocUDFs using entrypoint 'truncate' f.e. F_TRUNCATE */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND (F.RDB$ENTRYPOINT = 'truncate' OR F.RDB$ENTRYPOINT = 'f_truncate'));

/* all FreeAdhocUDFs using entrypoint 'zahlrunden' f.e. F_ZAHLRUNDEN */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'zahlrunden');

/* all FreeAdhocUDFs using entrypoint 'intrandom' f.e. F_INTRANDOM */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = -1
WHERE FA.RDB$ARGUMENT_POSITION = 0 AND FA.RDB$MECHANISM = 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'intrandom');

/* adhoc 2008-01-02 */
