/*
 *   FreeAdhocUDF - copyright (c) 2004/2006 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *
 *   !!!!!!!!!!!!!!!!!! IMPORTANT !!!!!!!!!!!!!!!!!!!
 *   This is a NECESSARY update-script for your FreeAdhocUDf-string-functions
 *   if you want to use the posibility of return NULL in FireBird 2.0 (only!!!)
 *   If you have DECLAIRTED your UDFs with an older version than adhoc200612xx
 *   OR with a compatible version of this UDFs like FreeUDFLib, FreeUDFLibC, GrUDF ...
 *   You MUST FIRST run the adhoc200612update_string.sql-script!
 *   You can run the COMPLETE script even you have NOT all UDFs declaired.
 *
 *   AFTER running this update-script you must REconnect to your database before you test
 *
 *   Software distributed under the License is distributed on an
 *   "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 *   or implied. See the License for the specific language governing
 *   rights and limitations under the License.
 *
 */

/* all FreeAdhocUDFs using entrypoint 'equalstring' f.e. F_EQUALSTRING */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'equalstring');

/* all FreeAdhocUDFs using entrypoint 'findwordindex' f.e. F_STRSUB */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'findwordindex');

/* all FreeAdhocUDFs using entrypoint 'stringlength' f.e. F_STRINGLENGTH */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'stringlength');

/* all FreeAdhocUDFs using entrypoint 'strsub' f.e. F_STRSUB */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'strsub');

/* all FreeAdhocUDFs using entrypoint 'substr' f.e. F_SUBSTR */
UPDATE RDB$FUNCTION_ARGUMENTS FA SET FA.RDB$MECHANISM = 5
WHERE FA.RDB$ARGUMENT_POSITION > 0
AND EXISTS (SELECT 1 FROM RDB$FUNCTIONS F WHERE FA.RDB$FUNCTION_NAME = F.RDB$FUNCTION_NAME
AND F.RDB$MODULE_NAME CONTAINING 'FreeAdhocUDF' AND F.RDB$ENTRYPOINT = 'substr');

/* adhoc 2006-11-31 */
