/*
 *   FreeAdhocUDF - copyright (c) 2004/2007 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *      based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for all FreeAdhocUDF UDFs
 *   length of some cstring = 8190 or 4095
 *   because so you can use one this UDF 4 (8) times in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 byte internal use)
 *
 */

SET SQL DIALECT 3;

/******************************************************************************/
/****                User Defined Functions - BLOb Functions               ****/
/****            to use with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_BLOB2EXCEL
    BLOB NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'excelblob' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBASPCHAR
    BLOB NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'blobaspchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCAT
    BLOB,
    BLOB,
    BLOB
    RETURNS PARAMETER 3
    ENTRY_POINT 'blobcat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCATSTR
    BLOB,
    CSTRING(32760),
    BLOB
    RETURNS PARAMETER 3
    ENTRY_POINT 'blobcatstr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLEFT
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'blobleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLINE
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'blobline' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBLINECOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'bloblinecount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBMAXSEGMENTLENGTH
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobmaxsegmentlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBMID
    BLOB NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'blobmid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBREPLACESTRING
    BLOB,
    CSTRING(254),
    CSTRING(254),
    INTEGER,
    INTEGER,
    BLOB
    RETURNS PARAMETER 6
    ENTRY_POINT 'blobreplacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBRIGHT
    BLOB NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'blobright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSEGMENTCOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsegmentcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSIZE
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsize' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBSUBSTR
    BLOB NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobsubstr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRBLOB
    CSTRING(32760),
    BLOB
    RETURNS PARAMETER 2
    ENTRY_POINT 'strblob' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCOMPARE
    BLOB NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobcompare' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBWORDCOUNT
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'blobwordcount' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-02-06 ****/

DECLARE EXTERNAL FUNCTION F_RBLOBMID
    BLOB NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'r_blobmid' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-07-06 ****/

DECLARE EXTERNAL FUNCTION F_BLOBSTRPOS
    CSTRING(8190) NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBTEXTPOS
    CSTRING(8190) NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_textpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BLOBCMP
    BLOB NULL,
    BLOB NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'b_strcmp' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****              User Defined Functions - constant functions             ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_PI
    RETURNS DOUBLE PRECISION BY VALUE
ENTRY_POINT 'pi' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_E
    RETURNS DOUBLE PRECISION BY VALUE
ENTRY_POINT 'euler' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C
    RETURNS INTEGER BY VALUE
ENTRY_POINT 'c' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_G
    RETURNS DOUBLE PRECISION BY VALUE
ENTRY_POINT 'g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_K
    RETURNS DOUBLE PRECISION BY VALUE
ENTRY_POINT 'k' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****              User Defined Functions - converting functions           ****/
/****            to use with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

/* length */

DECLARE EXTERNAL FUNCTION F_C_IN2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'in2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FT2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ft2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_YD2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'yd2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MILE2KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mile2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SM2KM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sm2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FM2M
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fm2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_P2MM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'p2mm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2IN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2in' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2ft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2YD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2yd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2MILE
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'km2mile' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2SM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'km2sm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'm2fm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MM2P
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'mm2p' MODULE_NAME 'FreeAdhocUDF';

/* area */

DECLARE EXTERNAL FUNCTION F_C_AR2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ar2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_HA2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ha2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MORGEN2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'morgen2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQFT2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqft2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_AC2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ac2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQYD2SQM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqyd2sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2AR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2HA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ha' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2MORGEN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2morgen' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2SQFT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2sqft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2AC
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2ac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SQM2SQYD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sqm2sqyd' MODULE_NAME 'FreeAdhocUDF';

/* volume */

DECLARE EXTERNAL FUNCTION F_C_BBL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bbl2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBFLOZ2ML
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbfloz2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USFLOZ2ML
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usfloz2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBPT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbpt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USPT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'uspt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBQT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbqt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USQT2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usqt2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_GBGAL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'gbgal2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_USGAL2L
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'usgal2l' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_RT2CBM
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'rt2cbm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2BBL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2bbl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2GBFLOZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ml2gbfloz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2USFLOZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ml2usfloz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBPT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbpt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USPT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2uspt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBQT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbqt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USQT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2usqt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2GBGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2gbgal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_L2USGAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'l2usgal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CBM2RT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cbm2rt' MODULE_NAME 'FreeAdhocUDF';

/* weight */

DECLARE EXTERNAL FUNCTION F_C_CT2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ct2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_OZ2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'oz2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_OZTR2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'oztr2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LB2KG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'lb2kg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2CT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2ct' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2OZ
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2oz' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2OZTR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2oztr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KG2LB
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kg2lb' MODULE_NAME 'FreeAdhocUDF';

/* technical */

DECLARE EXTERNAL FUNCTION F_C_G2T
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'g2t' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BAR2TORR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bar2torr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BAR2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bar2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PSI2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'psi2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TORR2PA
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'torr2pa' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CAL2J
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cal2j' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PS2KW
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'ps2kw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_BHP2KW
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'bhp2kw' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_T2G
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 't2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_TORR2BAR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'torr2bar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2BAR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2bar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2PSI
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2psi' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_PA2TORR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'pa2torr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_J2CAL
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'j2cal' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KW2PS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kw2ps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KW2BHP
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'kw2bhp' MODULE_NAME 'FreeAdhocUDF';

/* temperature */

DECLARE EXTERNAL FUNCTION F_C_C2F
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'c2f' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_F2C
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f2c' MODULE_NAME 'FreeAdhocUDF';

/* number system */

DECLARE EXTERNAL FUNCTION F_ROMAN2ARABIC
    CSTRING(50) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'roman2arabic' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARABIC2ROMAN
    INTEGER NULL
    RETURNS CSTRING(250) FREE_IT
    ENTRY_POINT 'arabic2roman' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTFROM33
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'convertfrom33' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTFROMBASE
    CSTRING(254) NULL,
    INTEGER NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'convertfrombase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTTO33
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'convertto33' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTTOBASE
    INTEGER NULL,
    INTEGER NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'converttobase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOHEX
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'inttohex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HEXTOINT
    CSTRING(20) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hextoint' MODULE_NAME 'FreeAdhocUDF';

/* geometrical */

DECLARE EXTERNAL FUNCTION F_DEGTORAD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'degtorad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RADTODEG
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'radtodeg' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-02-18 ****/

DECLARE EXTERNAL FUNCTION F_C_FUR2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'fur2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2FUR
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2fur' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CH2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'ch2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2CH
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2ch' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_RD2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'rd2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2RD
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2rd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LI2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'li2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2LI
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2li' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LEA2KM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'lea2km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KM2LEA
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'km2lea' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SHOT2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'shot2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2SHOT
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2shot' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CBL2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cbl2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2CBL
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2cbl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NL2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'nl2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2NL
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2nl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NM2M
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'nm2m' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_M2NM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'm2nm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUIN2CUM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cuin2cum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUM2CUIN
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cum2cuin' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUFT2CUB
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cuft2cum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUM2CUFT
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cum2cuft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUYD2CUB
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cuyd2cub' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUB2CUYD
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cum2cuyd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CUP2ML
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cup2ml' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ML2CUP
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'ml2cup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_ST2G
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'st2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2ST
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'g2st' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_CWT2G
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'cwt2g' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_G2CWT
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'g2cwt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_LBFT2NM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'lbft2nm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_NM2LBFT
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'nm2lbft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPUSGAL2L100KM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mpusgal2l100km' MODULE_NAME 'FreeAdhocUDF';

/* same entrypoint as F_C_MPUSGAL2L100KM */
DECLARE EXTERNAL FUNCTION F_C_L100KM2MPUSGAL
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mpusgal2l100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPGBGAL2L100KM
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mpgbgal2l100km' MODULE_NAME 'FreeAdhocUDF';

/* same entrypoint as F_C_MPGBGAL2L100KM */
DECLARE EXTERNAL FUNCTION F_C_L100KM2MPGBGAL
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mpgbgal2l100km' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPH2KMPH
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mph2kmph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KMPH2MPH
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'kmph2mph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_FPS2MPS
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'fps2mps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_MPS2FPS
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'mps2fps' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_SMPH2KMPH
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'smph2kmph' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_C_KMPH2SMPH
    DOUBLE PRECISION NULL
RETURNS DOUBLE PRECISION FREE_IT
ENTRY_POINT 'kmph2smph' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                 User Defined Functions: Date and TIME                ****/
/****       to use ONLY with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ADDDAY
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDHOUR
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addhour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMINUTE
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addminute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMONTH
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDSECOND
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addsecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDWEEK
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDYEAR
    TIMESTAMP NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'addyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTES
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutesnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTESTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutesthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARS
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARSTHRESHOLD
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsthresholdnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONG
    TIMESTAMP NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cdowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONG
    TIMESTAMP NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONGLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORT
    TIMESTAMP NULL
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cmonthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORTLANG
    TIMESTAMP NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFMONTH
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFWEEK
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSOFMONTH
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DTIME
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dtime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodedate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODETIME
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'encodetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODETIMESTAMP
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'encodetimestamp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equaldate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATETIME
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equaldatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GFORMATD
    CSTRING(254) NULL,
    TIMESTAMP NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'gformatd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOUR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOURSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hoursbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISLEAPYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAY
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'lastday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'maxdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINDATE
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'mindate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTE
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTESBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minutesbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTH
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'month' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTHSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'monthsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERDATUM
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'osterdatum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_QUARTER
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'quarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECOND
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'second' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'secondsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPDATE
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'stripdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPTIME
    TIMESTAMP NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'striptime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRTOTIME
    CSTRING(11) NULL
    RETURNS TIME FREE_IT
    ENTRY_POINT 'strtotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEK
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'week' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKOFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weekofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WOY
    TIMESTAMP NULL
    RETURNS CSTRING(8) FREE_IT
    ENTRY_POINT 'woy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'year' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAROFYEAR
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEARSBETWEEN
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZEITDIFFERENZ
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    CSTRING(1) NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zeitdifferenz' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-04-19 ****/

DECLARE EXTERNAL FUNCTION F_EXTRACTYEARDAY
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_yearday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXTRACTWEEKDAY
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_weekday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOW
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_dow' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RISLEAPYEAR
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATE
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'r_encodedate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATETIME
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'r_encodedatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTR
   TIMESTAMP NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'datetostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYMONTH
   TIMESTAMP NULL
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'firstdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYMONTH
   TIMESTAMP NULL
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'lastdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDPERIOD
   CSTRING(254) NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'addperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUBPERIOD
   CSTRING(254) NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'subperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PERIOD2SECONDS
   CSTRING(254) NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'period2seconds' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDS2PERIOD
   INTEGER NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'seconds2period' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TIMETODOUBLE
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'timetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETODOUBLE
    TIMESTAMP NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'datetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETOTIME
    DOUBLE PRECISION NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'doubletotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETODATE
    DOUBLE PRECISION NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'doubletodate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MILLISECOND
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'millisecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATE
   TIMESTAMP NULL,
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'incdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATETIME
   TIMESTAMP NULL,
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL
   RETURNS TIMESTAMP FREE_IT
   ENTRY_POINT 'incdatetime' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-01-02 ****/

DECLARE EXTERNAL FUNCTION F_KALENDERWOCHE
   TIMESTAMP NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'kalenderwoche' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEIBERFASTNACHT
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'weiberfastnacht' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROSENMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'rosenmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARNEVALSDIENSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karnevalsdienstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASCHERMITTWOCH
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'aschermittwoch' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PALMSONNTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'palmsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GRUENDONNERSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'gruendonnerstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARFREITAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karfreitag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERSAMSTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostersamstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostermontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HIMMELFAHRT
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'himmelfahrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTSONNTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTMONTAG
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRONLEICHNAM
    INTEGER NULL
    RETURNS DATE FREE_IT
    ENTRY_POINT 'fronleichnam' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-02-18 ****/

DECLARE EXTERNAL FUNCTION F_WOYISO
    TIMESTAMP NULL
RETURNS CSTRING(6) FREE_IT
ENTRY_POINT 'woyiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COUNTWEEKDAYS
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL
RETURNS INTEGER FREE_IT
ENTRY_POINT 'countweekdays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTRLANG
    TIMESTAMP NULL,
    CSTRING(254) NULL,
    CSTRING(2) NULL
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'datetostrlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSISO
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksnulliso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLDISO
    TIMESTAMP NULL,
    TIMESTAMP NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthresholdnulliso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEENISO
    TIMESTAMP NULL,
    TIMESTAMP NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetweeniso' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****            User Defined Functions - numeric/math functions           ****/
/****       to use ONLY with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ABS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOLLARVAL
    DOUBLE PRECISION NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'dollarval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLEABS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALFLOAT
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALINTEGER
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalinteger' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EUROVAL
    DOUBLE PRECISION NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'euroval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EVEN
    INTEGER NULL
    RETURNS INTEGER FREE_IT
ENTRY_POINT 'evenodd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACT
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACTORIAL
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINT
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'fixedpoint' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINTLANG
    DOUBLE PRECISION NULL,
    INTEGER NULL,
    CSTRING(1) NULL,
    CSTRING(1) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'fixedpointlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTEGERABS
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'integerabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTRANDOM
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'intrandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISDIVISIBLEBY
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isdivisibleby' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAX
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXNUM
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MIN
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINNUM
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MODULO
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'modulo' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROZENTE
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'prozente' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUND
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_round' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDFLOAT
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TRUNCATE
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_truncate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZAHLRUNDEN
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDCOMMON
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOFTROUND
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'softround' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASIN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOS
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN2
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan2_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCSIND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOSD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCTAND
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOTD
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SINH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sinhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'coshyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TANH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tanhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cothyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARSINH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arsinh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOSH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcosh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARTANH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'artanh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOTH
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcoth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RAND
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLERANDOM
    INTEGER NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doublerandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIGN
    DOUBLE PRECISION NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_sign' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQRT
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_sqrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LN
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ln' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG10
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log10' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOOR
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_floor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRAC
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_frac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CEILING
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ceiling' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_POWER
    DOUBLE PRECISION NULL,
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_power' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXP
    DOUBLE PRECISION NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_exp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_AND
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_and' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_OR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_or' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_XOR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_xor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_NOT
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_not' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHL
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHR
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shr' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-02-07 ****/

DECLARE EXTERNAL FUNCTION F_ROUNDTOEVEN
    DOUBLE PRECISION NULL,
    INTEGER NULL
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundtoeven' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NUMINWORDS
    DOUBLE PRECISION NULL,
    SMALLINT NULL,
    CSTRING(2) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'numinwords' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIV
    INTEGER NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_div' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_Z
   DOUBLE PRECISION
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'r_z'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DZERO
   DOUBLE PRECISION,
   DOUBLE PRECISION,
   DOUBLE PRECISION
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'r_dividezero'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GETRANDOM
   INTEGER NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'getrandom'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_GET
   INTEGER NULL,
   INTEGER NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_getbit'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SET
   INTEGER NULL,
   INTEGER NULL,
   INTEGER NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_setbit'  MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                   User Defined Functions - other functions           ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_IF
    CSTRING(32) NULL,
    CSTRING(8) NULL,
    CSTRING(32) NULL,
    CSTRING(8190) NULL,
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'aif' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_VERSION
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'version' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****              User Defined Functions - string functions               ****/
/****       to use ONLY with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ANSILOWERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ANSIUPPERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLEFT
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLRTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGMID
    CSTRING(32760) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACE
    CSTRING(32760) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACESTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRIGHT
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRINGLENGTH
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRINGHOLD
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
*    CSTRING(254) NULL,
*    CSTRING(32760) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC */
DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHARACTER
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHR
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COLLATEBR
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'collatebr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COPY
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'mid1' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CRLF
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'crlf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIGITS
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'digits' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'dqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCRYPTMD5
    CSTRING(128) NULL
    RETURNS CSTRING(33) FREE_IT
    ENTRY_POINT 'encryptmd5' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALSTRING
    CSTRING(8190) NULL,
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDNTHWORD
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'findnthword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDWORD
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'findword' MODULE_NAME 'FreeAdhocUDF';

/* version which returns -1 if not found
*DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
*    CSTRING(32760) NULL,
*    INTEGER NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'findwordindex' MODULE_NAME 'FreeAdhocUDF';
*/
/* version which returns <null> in FB 2.0 instead of -1 if not found */
DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'findwordindexnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GENERATESNDXINDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GSOUNDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'gsoundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOLDSTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT
    CSTRING(254) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT8
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LF
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'lf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LINEWRAP
    CSTRING(32760) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOWER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID4
    CSTRING(4095) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID8
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ORD
    CSTRING(1) NULL
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADCENTER
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADLEFT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADRIGHT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PRED
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROPERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'propercase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE4
    CSTRING(4095) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE8
    CSTRING(8190) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING4
    CSTRING(4095) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING8
    CSTRING(8190) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REVERSE
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT
    CSTRING(254) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT8
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOUNDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SPACE
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'space' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STR2EXCEL
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'excelstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCOPY
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'strcopy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGCOUNT
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH4
    CSTRING(4095) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH8
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLISTITEM
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(1024) FREE_IT
    ENTRY_POINT 'stringlistitem' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STROFCHAR
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'strofchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRRM
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'strrm' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with Delphi FreeUDFLib and NULL
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsubnull' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC
*  to use please uncomment it and comment the following version
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUCC
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAB
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'tab' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TELEFONNR
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'telefonnr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPPER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDCOUNT
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'wordcount' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-04-19 ****/

DECLARE EXTERNAL FUNCTION F_KEYUP
    CSTRING(32760) NULL,
    SMALLINT NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'keyup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADLEFT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADRIGHT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRPOS
    CSTRING(254) NULL,
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCMP
    CSTRING(8190) NULL,
    CSTRING(8190) NULL
    RETURNS INT FREE_IT
    ENTRY_POINT 'r_strcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RSTRINGCOUNT
    CSTRING(254) NULL,
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RWORDCOUNT
   CSTRING(32760) NULL,
   CSTRING(31) NULL,
   SMALLINT NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_wordcount'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDNUM
   CSTRING(32760) NULL,
   INTEGER NULL,
   CSTRING(31) NULL,
   SMALLINT NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'wordnum'  MODULE_NAME 'FreeAdhocUDF';

/* this is correct WITHOUT NULL because of the sence of the function */
DECLARE EXTERNAL FUNCTION F_RC
   CSTRING(254)
   RETURNS CSTRING(254)
   ENTRY_POINT 'r_c'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTSYMBOLS
   CSTRING(32760) NULL,
   CSTRING(254) NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(32760) FREE_IT
   ENTRY_POINT 'convertsymbols'  MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-07-04 ****/

DECLARE EXTERNAL FUNCTION F_REPEATTRIM
   CSTRING(8190) NULL,
   CSTRING(1) NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'repeattrim'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRREPEAT
   CSTRING(254) NULL,
   SMALLINT NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'strrepeat'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRSTUFF
   CSTRING(8190) NULL,
   SMALLINT NULL,
   SMALLINT NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'strstuff'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOATTOSTR
   DOUBLE PRECISION NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'floattostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOSTR
   INTEGER NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'inttostr' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-11-28 ****/

DECLARE EXTERNAL FUNCTION F_RUPPER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rupper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLOWER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rlower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLATIN
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rlatin' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-02-18 ****/

DECLARE EXTERNAL FUNCTION F_DOMAINFROMEMAIL
    CSTRING(254) NULL
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'domainfromemail' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROT13
    CSTRING(254) NULL
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'rot13' MODULE_NAME 'FreeAdhocUDF';

/******************************************************************************/
/****                User Defined Functions: UUID Functions                ****/
/****       to use ONLY with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_UUID1COMPRTIMESTAMP
    CSTRING(254) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1comprtimestamp' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1MAC
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1mac' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1maccompr' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1MACCOMPRMAC
    CSTRING(254) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1maccomprmac' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1MACMAC
    CSTRING(254) NULL
    RETURNS CSTRING(18) FREE_IT
    ENTRY_POINT 'uuid1macmac' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1RAND
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid1rand' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1RANDCOMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid1randcompr' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID1TIMESTAMP
    CSTRING(254) NULL
    RETURNS TIMESTAMP FREE_IT
    ENTRY_POINT 'uuid1timestamp' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID2UUIDCOMPR
    CSTRING(254) NULL
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'compressuuid' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID4
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'uuid4' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUID4COMPR
    RETURNS CSTRING(22) FREE_IT
    ENTRY_POINT 'uuid4compr' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUIDCOMPR2UUID
    CSTRING(254) NULL
    RETURNS CSTRING(36) FREE_IT
    ENTRY_POINT 'expanduuidcompr' MODULE_NAME 'FreeAdhocUDF';


DECLARE EXTERNAL FUNCTION F_UUIDVERSION
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'uuidversion' MODULE_NAME 'FreeAdhocUDF';

// adhoc 2008-12-03
