/*
 *   FreeAdhocUDF - copyright (c) 2004-2008 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *      based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for all FreeAdhocUDF UDFs
 *   Notice: to use with dialect 3 (DATE-field is DATE)
 *   length of some cstring = 8190 or 4095
 *   because so you can use one this UDF 4 (8) DATEs in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 byte internal use)
 *   Functions in alphabetical order
 *
 *   This script is not longer updated (last 12-2006)
 */

SET SQL DIALECT 1;

/******************************************************************************/
/****                 User Defined Functions: DATE, TIME and TIMESTAMP     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ADDDAY
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDHOUR
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addhour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMINUTE
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addminute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMONTH
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDSECOND
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addsecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDWEEK
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDYEAR
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhours' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTES
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutes' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTESTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutesthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonths' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinseconds' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeks' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyears' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONG
    DATE
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONGLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORT
    DATE
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cdowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORTLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONG
    DATE
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONGLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORT
    DATE
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cmonthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORTLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFMONTH
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFWEEK
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSOFMONTH
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DDATE
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATE
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATEDATE
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalDATEDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GFORMATD
    CSTRING(254),
    DATE
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'gformatd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOUR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOURSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hoursbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISLEAPYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAY
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'lastday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXDATE
    DATE,
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'maxDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINDATE
    DATE,
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'minDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTE
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTESBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minutesbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTH
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'month' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTHSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'monthsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERDATUM
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'osterdatum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_QUARTER
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'quarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECOND
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'second' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'secondsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPDATE
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'stripdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPTIME
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'striptime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRTOTIME
    CSTRING(11)
    RETURNS DATE FREE_IT
    ENTRY_POINT 'strtotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEK
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'week' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKOFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weekofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WOY
    DATE
    RETURNS CSTRING(8) FREE_IT
    ENTRY_POINT 'woy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'year' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAROFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEARSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZEITDIFFERENZ
    DATE,
    DATE,
    CSTRING(1)
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zeitdifferenz' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-04-19 ****/

DECLARE EXTERNAL FUNCTION F_EXTRACTYEARDAY
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_yearday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXTRACTWEEKDAY
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_weekday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOW
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_dow' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RISLEAPYEAR
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'r_encodedate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RENCODEDATETIME
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'r_encodedatetime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTR
   DATE,
   CSTRING(254)
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'datetostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIRSTDAYMONTH
   DATE
   RETURNS DATE FREE_IT
   ENTRY_POINT 'firstdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAYMONTH
   DATE
   RETURNS DATE FREE_IT
   ENTRY_POINT 'lastdaymonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDPERIOD
   CSTRING(254),
   CSTRING(254)
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'addperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUBPERIOD
   CSTRING(254),
   CSTRING(254)
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'subperiod' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PERIOD2SECONDS
   CSTRING(254)
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'period2seconds' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDS2PERIOD
   INTEGER
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'seconds2period' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TIMETODOUBLE
    DATE
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'timetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETODOUBLE
    DATE
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'datetodouble' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETOTIME
    DOUBLE PRECISION
    RETURNS DATE FREE_IT
    ENTRY_POINT 'doubletotime' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLETODATE
    DOUBLE PRECISION
    RETURNS DATE FREE_IT
    ENTRY_POINT 'doubletodate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MILLISECOND
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'millisecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATE
   DATE,
   INTEGER,
   INTEGER,
   INTEGER
   RETURNS DATE FREE_IT
   ENTRY_POINT 'incdate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INCDATETIME
   DATE,
   INTEGER,
   INTEGER,
   INTEGER,
   INTEGER,
   INTEGER,
   INTEGER
   RETURNS DATE FREE_IT
   ENTRY_POINT 'incdatetime' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-01-02 ****/

DECLARE EXTERNAL FUNCTION F_KALENDERWOCHE
   DATE
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'kalenderwoche' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEIBERFASTNACHT
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'weiberfastnacht' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROSENMONTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'rosenmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARNEVALSDIENSTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karnevalsdienstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASCHERMITTWOCH
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'aschermittwoch' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PALMSONNTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'palmsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GRUENDONNERSTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'gruendonnerstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_KARFREITAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'karfreitag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERSAMSTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostersamstag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERMONTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'ostermontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HIMMELFAHRT
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'himmelfahrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTSONNTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstsonntag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PFINGSTMONTAG
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'pfingstmontag' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRONLEICHNAM
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'fronleichnam' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-02-18 */ ****/

DECLARE EXTERNAL FUNCTION F_WOYISO
    DATE
RETURNS CSTRING(6) FREE_IT
ENTRY_POINT 'woyiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COUNTWEEKDAYS
    DATE,
    DATE,
    INTEGER
RETURNS INTEGER FREE_IT
ENTRY_POINT 'countweekdays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DATETOSTRLANG
    DATE,
    CSTRING(254),
    CSTRING(2)
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'datetostrlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSISO
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLDISO
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthresholdiso' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEENISO
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetweeniso' MODULE_NAME 'FreeAdhocUDF';
