/*
 *   FreeAdhocUDF - copyright (c) 2004-2008 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *      based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for all FreeAdhocUDF UDFs
 *   length of some cstring = 8190 or 4095
 *   because so you can use one this UDF 4 (8) times in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 byte internal use)
 *   Functions in alphabetical order
 *
 *   new functions at the end of the scipt
 */

/******************************************************************************/
/****            User Defined Functions - numeric/math functions           ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ABS
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOLLARVAL
    DOUBLE PRECISION
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'dollarval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLEABS
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doubleabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALFLOAT
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALINTEGER
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalinteger' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EUROVAL
    DOUBLE PRECISION
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'euroval' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EVEN
    INTEGER
    RETURNS INTEGER FREE_IT
ENTRY_POINT 'evenodd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACT
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FACTORIAL
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'fact' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINT
    DOUBLE PRECISION ,
    INTEGER
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'fixedpoint' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FIXEDPOINTLANG
    DOUBLE PRECISION ,
    INTEGER ,
    CSTRING(1) ,
    CSTRING(1)
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'fixedpointlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTEGERABS
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'integerabs' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTRANDOM
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'intrandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISDIVISIBLEBY
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isdivisibleby' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAX
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXNUM
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'maxnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MIN
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINNUM
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'minnum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MODULO
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'modulo' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROZENTE
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'prozente' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUND
    DOUBLE PRECISION
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_round' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDFLOAT
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundfloat' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TRUNCATE
    DOUBLE PRECISION
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_truncate' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZAHLRUNDEN
    DOUBLE PRECISION ,
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROUNDCOMMON
    DOUBLE PRECISION ,
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zahlrunden' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOFTROUND
    DOUBLE PRECISION,
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'softround' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIN
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COS
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAN
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COT
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ASIN
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOS
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ATAN2
    DOUBLE PRECISION,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan2_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ACOT
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_rad' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIND
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSD
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAND
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTD
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCSIND
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcsin_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOSD
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccos_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCTAND
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arctan_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCCOTD
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arccot_deg' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SINH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'sinhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COSH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'coshyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TANH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'tanhyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COTH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'cothyp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARSINH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arsinh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOSH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcosh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARTANH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'artanh' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ARCOTH
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'arcoth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RAND
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_rand' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DOUBLERANDOM
    INTEGER ,
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'doublerandom' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SIGN
    DOUBLE PRECISION
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_sign' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQRT
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_sqrt' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LN
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ln' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOG10
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_log10' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOOR
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_floor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FRAC
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_frac' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CEILING
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_ceiling' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_POWER
    DOUBLE PRECISION ,
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_power' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EXP
    DOUBLE PRECISION
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'f_exp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_AND
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_and' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_OR
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_or' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_XOR
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_xor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_NOT
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_not' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHL
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shl' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SHR
    INTEGER ,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'f_bin_shr' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-02-07 ****/

DECLARE EXTERNAL FUNCTION F_ROUNDTOEVEN
    DOUBLE PRECISION ,
    INTEGER
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'roundtoeven' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NUMINWORDS
    DOUBLE PRECISION,
    SMALLINT,
    CSTRING(2)
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'numinwords' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIV
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_div' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_Z
   DOUBLE PRECISION
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'r_z'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DZERO
   DOUBLE PRECISION,
   DOUBLE PRECISION,
   DOUBLE PRECISION
   RETURNS DOUBLE PRECISION BY VALUE
   ENTRY_POINT 'r_dividezero'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GETRANDOM
   INTEGER
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'getrandom'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_GET
   INTEGER,
   INTEGER
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_getbit'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIN_SET
   INTEGER,
   INTEGER,
   INTEGER
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_setbit'  MODULE_NAME 'FreeAdhocUDF';
