/*
 *   FreeAdhocUDF - copyright (c) 2004-2008 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *      based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for all FreeAdhocUDF UDFs
 *   length of some cstring = 8190 or 4095
 *   because so you can use one this UDF 4 (8) times in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 byte internal use)
 *   Functions in alphabetical order
 *
 *   new functions at the end of the scipt
 */


/******************************************************************************/
/****              User Defined Functions - string functions               ****/
/****       to use ONLY with FireBird 2.x - possibility to return NULL     ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ANSILOWERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ANSIUPPERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLEFT
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLRTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGLTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGMID
    CSTRING(32760) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACE
    CSTRING(32760) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGREPLACESTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRIGHT
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGRTRIM
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRINGLENGTH
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_BIGSTRIPSTRINGHOLD
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
*    CSTRING(254) NULL,
*    CSTRING(32760) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC */
DECLARE EXTERNAL FUNCTION F_BIGSUBSTR
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHARACTER
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CHR
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'character' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COLLATEBR
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'collatebr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_COPY
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'mid1' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CRLF
    RETURNS CSTRING(3) FREE_IT
    ENTRY_POINT 'crlf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DIGITS
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'digits' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'dqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCRYPTMD5
    CSTRING(128) NULL
    RETURNS CSTRING(33) FREE_IT
    ENTRY_POINT 'encryptmd5' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALSTRING
    CSTRING(8190) NULL,
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDNTHWORD
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'findnthword' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FINDWORD
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'findword' MODULE_NAME 'FreeAdhocUDF';

/* version which returns -1 if not found
*DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
*    CSTRING(32760) NULL,
*    INTEGER NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'findwordindex' MODULE_NAME 'FreeAdhocUDF';
*/
/* version which returns <null> in FB 2.0 instead of -1 if not found */
DECLARE EXTERNAL FUNCTION F_FINDWORDINDEX
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'findwordindexnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GENERATESNDXINDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GSOUNDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'gsoundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOLDSTRING
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT
    CSTRING(254) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LEFT8
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'left' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LF
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'lf' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LINEWRAP
    CSTRING(32760) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'linewrap' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LOWER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'lower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LRTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'ltrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID4
    CSTRING(4095) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MID8
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'mid' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_NBSP
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'nbsp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ORD
    CSTRING(1) NULL
    RETURNS SMALLINT FREE_IT
    ENTRY_POINT 'ord' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADCENTER
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padcenter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADLEFT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PADRIGHT
    CSTRING(4095) NULL,
    CSTRING(16) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PRED
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'predecessor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_PROPERCASE
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'propercase' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE4
    CSTRING(4095) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACE8
    CSTRING(8190) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'replace' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING4
    CSTRING(4095) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REPLACESTRING8
    CSTRING(8190) NULL,
    CSTRING(254) NULL,
    CSTRING(254) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'replacestring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_REVERSE
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'reverse' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT
    CSTRING(254) NULL,
    INTEGER NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT4
    CSTRING(4095) NULL,
    INTEGER NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RIGHT8
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'right' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'rtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM4
    CSTRING(4095) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RTRIM8
    CSTRING(8190) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'lrtrim' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SOUNDEX
    CSTRING(8190) NULL
    RETURNS CSTRING(6) FREE_IT
    ENTRY_POINT 'soundex' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SPACE
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'space' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SQM
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'sqm' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STR2EXCEL
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'excelstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCOPY
    CSTRING(8190) NULL,
    INTEGER NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'strcopy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGCOUNT
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH4
    CSTRING(4095) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLENGTH8
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'stringlength' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRINGLISTITEM
    CSTRING(32760) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(1024) FREE_IT
    ENTRY_POINT 'stringlistitem' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRING8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'stripstring' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPSTRINGHOLD8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'stripstringhold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STROFCHAR
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'strofchar' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRRM
    CSTRING(8190) NULL,
    INTEGER NULL
    RETURNS CSTRING(8190) FREE_IT
    ENTRY_POINT 'strrm' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with Delphi FreeUDFLib
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsub' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with Delphi FreeUDFLib and NULL
*  to use please uncomment it and comment the following version
*
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'strsubnull' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC
*  to use please uncomment it and comment the following version
*DECLARE EXTERNAL FUNCTION F_SUBSTR
*    CSTRING(254) NULL,
*    CSTRING(254) NULL
*    RETURNS INTEGER FREE_IT
*    ENTRY_POINT 'substr' MODULE_NAME 'FreeAdhocUDF';
*/

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR
    CSTRING(254) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR4
    CSTRING(4095) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

/* Version compatible with FreeUDFLibC and NULL */
DECLARE EXTERNAL FUNCTION F_SUBSTR8
    CSTRING(8190) NULL,
    CSTRING(254) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'substrnull' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SUCC
    CSTRING(1) NULL,
    INTEGER NULL
    RETURNS CSTRING(1) FREE_IT
    ENTRY_POINT 'successor' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TAB
    RETURNS CSTRING(2) FREE_IT
    ENTRY_POINT 'tab' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_TELEFONNR
    CSTRING(32760) NULL,
    INTEGER NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'telefonnr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_UPPER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'upper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDCOUNT
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'wordcount' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-04-19 ****/

DECLARE EXTERNAL FUNCTION F_KEYUP
    CSTRING(32760) NULL,
    SMALLINT NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'keyup' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADLEFT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padleft' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RPADRIGHT
    CSTRING(4095) NULL,
    INTEGER NULL,
    CSTRING(16) NULL
    RETURNS CSTRING(4095) FREE_IT
    ENTRY_POINT 'r_padright' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRPOS
    CSTRING(254) NULL,
    CSTRING(8190) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'strpos' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRCMP
    CSTRING(8190) NULL,
    CSTRING(8190) NULL
    RETURNS INT FREE_IT
    ENTRY_POINT 'r_strcmp' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RSTRINGCOUNT
    CSTRING(254) NULL,
    CSTRING(32760) NULL
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'r_stringcount' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RWORDCOUNT
   CSTRING(32760) NULL,
   CSTRING(31) NULL,
   SMALLINT NULL
   RETURNS INTEGER FREE_IT
   ENTRY_POINT 'r_wordcount'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WORDNUM
   CSTRING(32760) NULL,
   INTEGER NULL,
   CSTRING(31) NULL,
   SMALLINT NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'wordnum'  MODULE_NAME 'FreeAdhocUDF';

/* this is correct WITHOUT NULL because of the sence of the function */
DECLARE EXTERNAL FUNCTION F_RC
   CSTRING(254)
   RETURNS CSTRING(254)
   ENTRY_POINT 'r_c'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CONVERTSYMBOLS
   CSTRING(32760) NULL,
   CSTRING(254) NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(32760) FREE_IT
   ENTRY_POINT 'convertsymbols'  MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-07-04 ****/

DECLARE EXTERNAL FUNCTION F_REPEATTRIM
   CSTRING(8190) NULL,
   CSTRING(1) NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'repeattrim'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRREPEAT
   CSTRING(254) NULL,
   SMALLINT NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'strrepeat'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRSTUFF
   CSTRING(8190) NULL,
   SMALLINT NULL,
   SMALLINT NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(8190) FREE_IT
   ENTRY_POINT 'strstuff'  MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_FLOATTOSTR
   DOUBLE PRECISION NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'floattostr' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_INTTOSTR
   INTEGER NULL,
   CSTRING(254) NULL
   RETURNS CSTRING(254) FREE_IT
   ENTRY_POINT 'inttostr' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2007-11-28 ****/

DECLARE EXTERNAL FUNCTION F_RUPPER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rupper' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLOWER
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rlower' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_RLATIN
    CSTRING(32760) NULL
    RETURNS CSTRING(32760) FREE_IT
    ENTRY_POINT 'rlatin' MODULE_NAME 'FreeAdhocUDF';

/*** new functions 2008-02-18 ****/

DECLARE EXTERNAL FUNCTION F_DOMAINFROMEMAIL
    CSTRING(254) NULL
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'domainfromemail' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ROT13
    CSTRING(254) NULL
RETURNS CSTRING(254) FREE_IT
ENTRY_POINT 'rot13' MODULE_NAME 'FreeAdhocUDF';

// adhoc 2008-12-03
